package std;

import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.LayoutManager;

public class JWolfsLayout implements LayoutManager
{
	public final static int BREAKBEHIND 		= 2;
	public final static int BREAKBEFORE 		= 4;
	public final static int TABULATORBEHIND		= 8;
	public final static int TABULATORBEFORE		= 16;
	
	private int nTabRating;
	private int nMaxWidth;
	private int	nMaxHeight;
	private int	nCursorX;
	private int	nCursorY;
	private int nPadLeft;
	private int nPadTop;
	private int nPadRight;
	private int nPadBottom;
	private int nLastHeight;
	
	public JWolfsLayout () 
	{
	    this.nTabRating		= 100;
	    
	    return;
	}
	
	public void setPadding (int nLeft, int nTop, int nRight, int nBottom)
	{
		
		this.nPadLeft 		= nLeft;
		this.nPadTop		= nTop;
		this.nPadRight		= nRight;
		this.nPadBottom		= nBottom;
		
		return;
	}
	
	public void setTablutorRating (int nTabRating)
	{
		
		this.nTabRating = nTabRating;
		
		return;
	}
	
	public void setStartPosition (int nX, int nY)
	{
		
		this.nCursorX = nX;
		this.nCursorY = nY;
		
		return;
	}

	@Override
	public void addLayoutComponent (String sLevelID, Component objComponent) 
	{
		int btStyle = new Integer (sLevelID);

		if ((btStyle & BREAKBEFORE) == BREAKBEFORE)
		{
			this.nCursorX 	 = 0;
			this.nCursorY	+= this.nPadTop + this.nLastHeight + this.nPadBottom;
			this.nLastHeight = 0;
		}
		
		if ((btStyle & TABULATORBEFORE) == TABULATORBEFORE)
		{
			this.nCursorX = (int)((((float)this.nCursorX + (float)this.nTabRating) / (float)this.nTabRating) * (float)this.nTabRating);
		}

		this.nCursorX += this.nPadLeft;
		objComponent.setBounds (this.nCursorX, this.nCursorY, objComponent.getWidth (), objComponent.getHeight ());
		this.nCursorX += objComponent.getWidth () + this.nPadRight;

		if (this.nLastHeight < objComponent.getHeight ()) this.nLastHeight = objComponent.getHeight ();
		
		if ((btStyle & BREAKBEHIND) == BREAKBEHIND)
		{
			this.nCursorX 	 = 0;
			this.nCursorY	+= this.nPadTop + this.nLastHeight + this.nPadBottom;
			this.nLastHeight = 0;
		}

		if ((btStyle & TABULATORBEHIND) == TABULATORBEHIND)
		{
			this.nCursorX = (int)((((float)this.nCursorX + (float)this.nTabRating) / (float)this.nTabRating) * (float)this.nTabRating);
		}
		
		if (this.nMaxWidth < this.nCursorX) this.nMaxWidth = this.nCursorX;
		if (this.nMaxHeight < this.nCursorY) this.nMaxHeight = this.nCursorY;
		
		this.nLastHeight = objComponent.getHeight ();
				
		return;
	}

	@Override
	public void layoutContainer (Container objParent) 
	{

		// Fr mgliche Erweiterungen.
		
	}

	@Override
	public Dimension minimumLayoutSize(Container objParent) 
	{
		Dimension objDim = new Dimension (this.nMaxWidth, this.nMaxHeight);

		return objDim;
	}

	@Override
	public Dimension preferredLayoutSize(Container objParent) 
	{

		return this.minimumLayoutSize (objParent);
	}

	@Override
	public void removeLayoutComponent(Component objComponent) 
	{

		// Fr mgliche Erweiterungen.
		
		return;
	}
	
	public static String style (int btStyle)
	{		
		
		return new String ("" + btStyle);
	}

	public void setBreak ()
	{		
		
		this.nCursorX 	 = 0;
		this.nCursorY	+= this.nPadTop + this.nLastHeight + this.nPadBottom;
		
		return;
	}
}
